<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>State.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">vendingmachine</a> &gt; <a href="index.source.html" class="el_package">com.example.vendingmachine.entity</a> &gt; <span class="el_source">State.java</span></div><h1>State.java</h1><pre class="source lang-java linenums">package com.example.vendingmachine.entity;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.Optional;

import com.example.vendingmachine.component.VirtualVendingMachine;
import com.example.vendingmachine.repository.ProductRepository;

<span class="fc" id="L10">public enum State {</span>

<span class="fc" id="L12">    INIT {</span>
        @Override
        public void insertCoin(Coin coin, VirtualVendingMachine machine) {
<span class="fc" id="L15">            machine.setCurrentAmount(machine.getCurrentAmount().add(coinAmount(coin)));</span>
<span class="fc" id="L16">            machine.setCurrentOuptut(&quot;Inserted coin &quot; + coin + &quot; and current amount is: &quot; +</span>
<span class="fc" id="L17">                    toMoney(machine.getCurrentAmount()));</span>
<span class="fc" id="L18">            machine.setCurrentState(WAIT);</span>
<span class="fc" id="L19">        }</span>

        @Override
        public void reset(VirtualVendingMachine machine) {
<span class="fc" id="L23">            machine.setCurrentOuptut(&quot;No coins to be returned&quot;);</span>
<span class="fc" id="L24">        }</span>

        @Override
        public void buyProductById(long id, ProductRepository productRepository, VirtualVendingMachine machine) {
<span class="fc" id="L28">            machine.setCurrentOuptut(&quot;Please insert coins in order to buy product&quot;);</span>
<span class="fc" id="L29">        }</span>
    },
<span class="fc" id="L31">    WAIT {</span>
        @Override
        public void insertCoin(Coin coin, VirtualVendingMachine machine) {
<span class="fc" id="L34">            machine.setCurrentAmount(machine.getCurrentAmount().add(coinAmount(coin)));</span>
<span class="fc" id="L35">            machine.setCurrentOuptut(&quot;Inserted coin &quot; + coin + &quot; and current amount is: &quot;</span>
<span class="fc" id="L36">                    + toMoney(machine.getCurrentAmount()));</span>
<span class="fc" id="L37">            machine.setCurrentState(WAIT);</span>
<span class="fc" id="L38">        }</span>

        @Override
        public void reset(VirtualVendingMachine machine) {
<span class="fc" id="L42">            machine.setCurrentOuptut(&quot;Amount to be returned: &quot; +</span>
<span class="fc" id="L43">                    toMoney(machine.getCurrentAmount()));</span>
<span class="fc" id="L44">            machine.setCurrentAmount(new BigDecimal(&quot;0.00&quot;));</span>
<span class="fc" id="L45">            machine.setCurrentState(INIT);</span>
<span class="fc" id="L46">        }</span>

        @Override
        public void buyProductById(long id, ProductRepository productRepository, VirtualVendingMachine machine) {
<span class="fc" id="L50">            Optional&lt;Product&gt; product = productRepository.findById(id);</span>
<span class="fc bfc" id="L51" title="All 2 branches covered.">            if (product.isPresent()) {</span>
<span class="fc bfc" id="L52" title="All 2 branches covered.">                if (machine.getCurrentAmount().compareTo(product.get().getPrice()) &gt;= 0) {</span>
<span class="fc" id="L53">                    machine.setCurrentOuptut(&quot;Product was purchased. Thank you!&quot;);</span>
<span class="fc" id="L54">                    machine.setCurrentAmount(new BigDecimal(&quot;0.00&quot;));</span>
<span class="fc" id="L55">                    machine.getProductRepository().deleteById(product.get().getId());</span>
<span class="fc" id="L56">                    machine.setCurrentState(INIT);</span>
                } else {
<span class="fc" id="L58">                    machine.setCurrentOuptut(</span>
<span class="fc" id="L59">                            &quot;Please insert more coins. You need to insert: &quot; + toMoney(product.get().getPrice()</span>
<span class="fc" id="L60">                                    .subtract(machine.getCurrentAmount())));</span>
                }
            } else {
<span class="fc" id="L63">                machine.setCurrentOuptut(&quot;The requested product is not awailable please select other product&quot;);</span>
            }

<span class="fc" id="L66">        }</span>
    };

    public abstract void insertCoin(Coin coin, VirtualVendingMachine machine);

    public abstract void reset(VirtualVendingMachine machine);

    public abstract void buyProductById(long id, ProductRepository productRepository, VirtualVendingMachine machine);

    private final static BigDecimal coinAmount(Coin coin) {
<span class="fc" id="L76">        BigDecimal amount = null;</span>
<span class="pc bpc" id="L77" title="1 of 6 branches missed.">        switch (coin) {</span>
            case _10ST:
<span class="fc" id="L79">                amount = new BigDecimal(0.10);</span>
<span class="fc" id="L80">                break;</span>
            case _1LV:
<span class="fc" id="L82">                amount = new BigDecimal(1.00);</span>
<span class="fc" id="L83">                break;</span>
            case _20ST:
<span class="fc" id="L85">                amount = new BigDecimal(0.20);</span>
<span class="fc" id="L86">                break;</span>
            case _2LV:
<span class="fc" id="L88">                amount = new BigDecimal(2.00);</span>
<span class="fc" id="L89">                break;</span>
            case _50ST:
<span class="fc" id="L91">                amount = new BigDecimal(0.50);</span>
<span class="fc" id="L92">                break;</span>
            default:
                break;
        }
<span class="fc" id="L96">        return amount;</span>

    }

    public final static String toMoney(BigDecimal bd) {
<span class="fc" id="L101">        DecimalFormat df = new DecimalFormat(&quot;##0.00&quot;);</span>
<span class="fc" id="L102">        return df.format(bd);</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.8.202204050719</span></div></body></html>